diff --git a/blivet/devices.py b/blivet/devices.py
index 58a3cb1..14a58a9 100644
--- a/blivet/devices.py
+++ b/blivet/devices.py
@@ -20,79 +20,6 @@
 # Red Hat Author(s): Dave Lehman <dlehman@redhat.com>
 #
 
-
-"""
-    Device classes for use by anaconda.
-
-    This is the hierarchy of device objects that anaconda will use for
-    managing storage devices in the system. These classes will
-    individually make use of external support modules as needed to
-    perform operations specific to the type of device they represent.
-
-    TODO:
-        - see how to do network devices (NetworkManager may help)
-          - perhaps just a wrapper here
-        - document return values of all methods/functions
-        - find out what other kinds of wild and crazy devices we need to
-          represent here (iseries? xen? more mainframe? mac? ps?)
-            - PReP
-              - this is a prime candidate for a PseudoDevice
-            - DASD
-            - ZFCP
-            - XEN
-
-    What specifications do we allow?              new        existing
-        partitions                              
-            usage                                  +            +
-                filesystem, partition type are implicit
-            mountpoint                             +            +
-            size
-                exact                              +            -
-                range                              +            -
-                resize                             -            +
-            format                                 -            +
-            encryption                             +            +
-
-            disk                                                 
-                exact                              +            -
-                set                                +            -
-                    how will we specify this?
-                        partition w/ multiple parents cannot otherwise occur
-            primary                                +            -
-
-        mdraid sets
-            filesystem (*)                         +            +
-            mountpoint                             +            +
-            size?                                                
-            format                                 -            +
-            encryption                             +            +
-
-            level                                  +            ? 
-            device minor                           +            ? 
-            member devices                         +            ? 
-            spares                                 +            ? 
-            name?
-            bitmap? (boolean)                      +            -
-
-        volume groups
-            name                                   +            - 
-            member pvs                             +            +
-            pesize                                 +            ?
-
-        logical volumes
-            filesystem                             +            +
-            mountpoint                             +            +
-            size
-                exact                              +            ?
-            format                                 -            +
-            encryption                             +            +
-
-            name                                   +            ?
-            vgname                                 +            ?
-
-
-"""
-
 import os
 import math
 import copy
@@ -142,6 +69,13 @@ device_majors = get_device_majors()
 
 
 def devicePathToName(devicePath):
+    """ Return a name based on the given path to a device node.
+
+        :param devicePath: the path to a device node
+        :type devicePath: str
+        :returns: the name
+        :rtype: str
+    """
     if devicePath.startswith("/dev/"):
         name = devicePath[5:]
     else:
@@ -157,6 +91,13 @@ def devicePathToName(devicePath):
 
 
 def deviceNameToDiskByPath(deviceName=None):
+    """ Return a /dev/disk/by-path/ symlink path for the given device name.
+
+        :param deviceName: the device name
+        :type deviceName: str
+        :returns: the full path to a /dev/disk/by-path/ symlink, or None
+        :rtype: str or NoneType
+    """
     if not deviceName:
         return ""
 
@@ -212,16 +153,11 @@ class Device(object):
     _services = []
 
     def __init__(self, name, parents=None):
-        """ Create a Device instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-
-            Keyword Arguments:
-
-                parents -- a list of required Device instances
-
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`Device` instances
         """
         self._name = name
         if parents is None:
@@ -280,10 +216,12 @@ class Device(object):
         return d
 
     def removeChild(self):
+        """ Decrement the child counter for this device. """
         log_method_call(self, name=self.name, kids=self.kids)
         self.kids -= 1
 
     def addChild(self):
+        """ Increment the child counter for this device. """
         log_method_call(self, name=self.name, kids=self.kids)
         self.kids += 1
 
@@ -304,18 +242,36 @@ class Device(object):
         raise NotImplementedError("destroy method not defined for Device")
 
     def setupParents(self, orig=False):
-        """ Run setup method of all parent devices. """
+        """ Run setup method of all parent devices.
+
+            :keyword orig: set up original format instead of current format
+            :type orig: bool
+        """
         log_method_call(self, name=self.name, orig=orig, kids=self.kids)
         for parent in self.parents:
             parent.setup(orig=orig)
 
     def teardownParents(self, recursive=None):
-        """ Run teardown method of all parent devices. """
+        """ Run teardown method of all parent devices.
+
+            :keyword recursive: tear down all ancestor devices recursively
+            :type recursive: bool
+        """
         for parent in self.parents:
             parent.teardown(recursive=recursive)
 
     def dependsOn(self, dep):
-        """ Return True if this device depends on dep. """
+        """ Return True if this device depends on dep.
+
+            This device depends on another device if the other device is an
+            ancestor of this device. For example, a PartitionDevice depends on
+            the DiskDevice on which it resides.
+
+            :param dep: the other device
+            :type dep: :class:`Device`
+            :returns: whether this device depends on 'dep'
+            :rtype: bool
+        """
         # XXX does a device depend on itself?
         if dep in self.parents:
             return True
@@ -331,12 +287,7 @@ class Device(object):
 
     @property
     def status(self):
-        """ This device's status.
-
-            For now, this should return a boolean:
-                True    the device is open and ready for use
-                False   the device is not open
-        """
+        """ Is this device currently active and ready for use? """
         return False
 
     @property
@@ -361,6 +312,7 @@ class Device(object):
 
     @property
     def ancestors(self):
+        """ A list of all of this device's ancestors, including itself. """
         l = set([self])
         for p in [d for d in self.parents if d not in l]:
             l.update(set(p.ancestors))
@@ -396,6 +348,7 @@ class Device(object):
 
     @property
     def mediaPresent(self):
+        """ True if this device contains usable media. """
         return True
 
 
@@ -403,9 +356,8 @@ class NetworkStorageDevice(object):
     """ Virtual base class for network backed storage devices """
 
     def __init__(self, host_address=None, nic=None):
-        """ Create a NetworkStorage Device instance. Note this class is only
-            to be used as a baseclass and then only with multiple inheritance.
-            The only correct use is:
+        """ Note this class is only to be used as a baseclass and then only with
+            multiple inheritance. The only correct use is:
             class MyStorageDevice(StorageDevice, NetworkStorageDevice):
 
             The sole purpose of this class is to:
@@ -414,10 +366,10 @@ class NetworkStorageDevice(object):
             2) To be able to get the host address of the host (server) backing
                the storage *or* the NIC through which the storage is connected
 
-            Arguments:
-
-                host_address -- host address of the backing server
-                nic -- nic to which the storage is bound
+            :keyword host_address: host address of the backing server
+            :type host_address: str
+            :keyword nic: NIC to which the block device is bound
+            :type nic: str
         """
         self.host_address = host_address
         self.nic = nic
@@ -430,10 +382,6 @@ class StorageDevice(Device):
         path attribute, although it is not guaranteed to be useful, or
         even present, unless the StorageDevice's setup method has been
         run.
-
-        StorageDevice instances can optionally contain a filesystem,
-        represented by an FS instance. A StorageDevice's create method
-        should create a filesystem if one has been specified.
     """
     _type = "blivet"
     _devDir = "/dev"
@@ -446,25 +394,33 @@ class StorageDevice(Device):
                  size=None, major=None, minor=None,
                  sysfsPath='', parents=None, exists=False, serial=None,
                  vendor="", model="", bus=""):
-        """ Create a StorageDevice instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-
-            Keyword Arguments:
-
-                size -- the device's size (units/format TBD)
-                major -- the device major
-                minor -- the device minor
-                sysfsPath -- sysfs device path
-                format -- a DeviceFormat instance
-                uuid -- universally unique identifier
-                parents -- a list of required Device instances
-                serial -- the ID_SERIAL_SHORT for this device
-                vendor -- the manufacturer of this Device
-                model -- manufacturer's device model string
-                bus -- the interconnect this device uses
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size (units/format TBD)
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword uuid: universally unique identifier (device -- not fs)
+            :type uuid: str
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+            :keyword major: the device major
+            :type major: int
+            :keyword minor: the device minor
+            :type minor: int
+            :keyword serial: the ID_SERIAL_SHORT for this device
+            :type serial: str
+            :keyword vendor: the manufacturer of this Device
+            :type vendor: str
+            :keyword model: manufacturer's device model string
+            :type model: str
+            :keyword bus: the interconnect this device uses
+            :type bus: str
 
         """
         # allow specification of individual parents
@@ -1003,7 +959,12 @@ class StorageDevice(Device):
             data.mountpoint += str(self.id)
 
 class DiskDevice(StorageDevice):
-    """ A disk """
+    """ A local/generic disk.
+
+        This is not the only kind of device that is treated as a disk. More
+        useful than checking isinstance(device, DiskDevice) is checking
+        device.isDisk.
+    """
     _type = "disk"
     _partitionable = True
     _isDisk = True
@@ -1012,26 +973,29 @@ class DiskDevice(StorageDevice):
                  size=None, major=None, minor=None, sysfsPath='',
                  parents=None, serial=None, vendor="", model="", bus="",
                  exists=True):
-        """ Create a DiskDevice instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-
-            Keyword Arguments:
-
-                size -- the device's size (units/format TBD)
-                major -- the device major
-                minor -- the device minor
-                sysfsPath -- sysfs device path
-                format -- a DeviceFormat instance
-                parents -- a list of required Device instances
-                removable -- whether or not this is a removable device
-                serial -- the ID_SERIAL_SHORT for this device
-                vendor -- the manufacturer of this Device
-                model -- manufacturer's device model string
-                bus -- the interconnect this device uses
-
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword size: the device's size (units/format TBD)
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword uuid: universally unique identifier (device -- not fs)
+            :type uuid: str
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+            :keyword removable: whether or not this is a removable device
+            :type removable: bool
+            :keyword serial: the ID_SERIAL_SHORT for this device
+            :type serial: str
+            :keyword vendor: the manufacturer of this Device
+            :type vendor: str
+            :keyword model: manufacturer's device model string
+            :type model: str
+            :keyword bus: the interconnect this device uses
+            :type bus: str
 
             DiskDevices always exist.
         """
@@ -1098,38 +1062,49 @@ class PartitionDevice(StorageDevice):
                  major=None, minor=None, bootable=None,
                  sysfsPath='', parents=None, exists=False,
                  partType=None, primary=False, weight=0):
-        """ Create a PartitionDevice instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-
-            Keyword Arguments:
-
-                exists -- indicates whether this is an existing device
-                format -- the device's format (DeviceFormat instance)
-
-                For existing partitions:
-
-                    parents -- the disk that contains this partition
-                    major -- the device major
-                    minor -- the device minor
-                    sysfsPath -- sysfs device path
-
-                For new partitions:
-
-                    partType -- primary,extended,&c (as parted constant)
-                    grow -- whether or not to grow the partition
-                    maxsize -- max size for growable partitions
-                    size -- the device's size (in MB)
-                    start -- start sector (see note, below)
-                    end -- end sector (see note, below)
-                    bootable -- whether the partition is bootable
-                    parents -- a list of potential containing disks
-                    weight -- an initial sorting weight to assign
-
-            NOTE: If start/end sectors are specified they will not be adjusted
-                  for optimal alignment. It is up to the caller to do that.
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+
+            For existing partitions only:
+
+            :keyword major: the device major
+            :type major: long
+            :keyword minor: the device minor
+            :type minor: long
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+
+            For non-existent partitions only:
+
+            :keyword partType: parted type constant, eg:
+                                :const:`parted.PARTITION_NORMAL`
+            :type partType: parted partition type constant
+            :keyword grow: whether or not to grow the partition
+            :type grow: bool
+            :keyword maxsize: max size for growable partitions
+            :type maxsize: :class:`~.size.Size`
+            :keyword start: start sector (see note, below)
+            :type start: long
+            :keyword end: end sector (see note, below)
+            :type end: long
+            :keyword bootable: whether the partition is bootable
+            :type bootable: bool
+            :keyword weight: an initial sorting weight to assign
+            :type weight: int
+
+            .. note::
+
+                If a start sector is specified the partition will not be
+                adjusted for optimal alignment. That is up to the caller.
         """
         self.req_disks = []
         self.req_partType = None
@@ -1785,21 +1760,23 @@ class DMDevice(StorageDevice):
 
     def __init__(self, name, format=None, size=None, dmUuid=None,
                  target=None, exists=False, parents=None, sysfsPath=''):
-        """ Create a DMDevice instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-
-            Keyword Arguments:
-
-                target -- the device-mapper target type (string)
-                size -- the device's size (units/format TBD)
-                dmUuid -- the device's device-mapper UUID
-                sysfsPath -- sysfs device path
-                format -- a DeviceFormat instance
-                parents -- a list of required Device instances
-                exists -- indicates whether this is an existing device
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+            :keyword dmUuid: device-mapper UUID
+            :type dmUuid: str
+            :keyword target: device mapper table/target name (eg: "linear")
+            :type target: str
         """
         StorageDevice.__init__(self, name, format=format, size=size,
                                exists=exists,
@@ -1902,20 +1879,21 @@ class DMLinearDevice(DMDevice):
 
     def __init__(self, name, format=None, size=None, dmUuid=None,
                  exists=False, parents=None, sysfsPath=''):
-        """ Create a DMLinearDevice instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-
-            Keyword Arguments:
-
-                size -- the device's size (units/format TBD)
-                dmUuid -- the device's device-mapper UUID
-                sysfsPath -- sysfs device path
-                format -- a DeviceFormat instance
-                parents -- a list of required Device instances
-                exists -- indicates whether this is an existing device
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+            :keyword dmUuid: device-mapper UUID
+            :type dmUuid: str
         """
         if not parents:
             raise ValueError("DMLinearDevice requires a backing block device")
@@ -1966,19 +1944,19 @@ class DMCryptDevice(DMDevice):
 
     def __init__(self, name, format=None, size=None, uuid=None,
                  exists=False, sysfsPath='', parents=None):
-        """ Create a DMCryptDevice instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-
-            Keyword Arguments:
-
-                size -- the device's size (units/format TBD)
-                sysfsPath -- sysfs device path
-                format -- a DeviceFormat instance
-                parents -- a list of required Device instances
-                exists -- indicates whether this is an existing device
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
         """
         DMDevice.__init__(self, name, format=format, size=size,
                           parents=parents, sysfsPath=sysfsPath,
@@ -1991,20 +1969,21 @@ class LUKSDevice(DMCryptDevice):
 
     def __init__(self, name, format=None, size=None, uuid=None,
                  exists=False, sysfsPath='', parents=None):
-        """ Create a LUKSDevice instance.
-
-            Arguments:
-
-                name -- the device name
-
-            Keyword Arguments:
-
-                size -- the device's size in MB
-                uuid -- the device's UUID
-                sysfsPath -- sysfs device path
-                format -- a DeviceFormat instance
-                parents -- a list of required Device instances
-                exists -- indicates whether this is an existing device
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+            :keyword uuid: the device UUID
+            :type uuid: str
         """
         DMCryptDevice.__init__(self, name, format=format, size=size,
                                parents=parents, sysfsPath=sysfsPath,
@@ -2050,28 +2029,32 @@ class LVMVolumeGroupDevice(DMDevice):
     def __init__(self, name, parents=None, size=None, free=None,
                  peSize=None, peCount=None, peFree=None, pvCount=None,
                  uuid=None, exists=False, sysfsPath=''):
-        """ Create a LVMVolumeGroupDevice instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-                parents -- a list of physical volumes (StorageDevice)
-
-            Keyword Arguments:
-
-                peSize -- physical extent size (in MB)
-                exists -- indicates whether this is an existing device
-                sysfsPath -- sysfs device path
-
-                For existing VG's only:
-
-                    size -- the VG's size (in MB)
-                    free -- amount of free space in the VG
-                    peFree -- number of free extents
-                    peCount -- total number of extents
-                    pvCount -- number of PVs in this VG
-                    uuid -- the VG's UUID
-
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+            :keyword peSize: physical extent size
+            :type peSize: :class:`~.size.Size`
+
+            For existing VG's only:
+
+            :keyword size: the VG's size
+            :type size: :class:`~.size.Size`
+            :keyword free -- amount of free space in the VG
+            :type free: :class:`~.size.Size`
+            :keyword peFree: number of free extents
+            :type peFree: int
+            :keyword peCount -- total number of extents
+            :type peCount: int
+            :keyword pvCount: number of PVs in this VG
+            :type pvCount: int
+            :keyword uuid: the VG UUID
+            :type uuid: str
         """
         self.pvClass = get_device_format_class("lvmpv")
         if not self.pvClass:
@@ -2486,31 +2469,43 @@ class LVMLogicalVolumeDevice(DMDevice):
                  format=None, exists=False, sysfsPath='',
                  grow=None, maxsize=None, percent=None,
                  singlePV=False):
-        """ Create a LVMLogicalVolumeDevice instance.
-
-            Arguments:
-
-                name -- the device name (generally a device node's basename)
-                vgdev -- volume group (LVMVolumeGroupDevice instance)
-
-            Keyword Arguments:
-
-                size -- the device's size (in MB)
-                uuid -- the device's UUID
-                copies -- number of copies in the vg (>1 for mirrored lvs)
-                logSize -- size of log volume (for mirrored lvs)
-                snapshotSpace -- sum of sizes of snapshots of this lv
-                sysfsPath -- sysfs device path
-                format -- a DeviceFormat instance
-                exists -- indicates whether this is an existing device
-                singlePV -- if true, maps this lv to a single pv
-                segType -- segment type (eg: "linear", "raid1")
-
-                For new (non-existent) LVs only:
-
-                    grow -- whether to grow this LV
-                    maxsize -- maximum size for growable LV (in MB)
-                    percent -- percent of VG space to take
+        """
+            :param name: the device name (generally a device node's basename)
+            :type name: str
+            :keyword exists: does this device exist?
+            :type exists: bool
+            :keyword size: the device's size
+            :type size: :class:`~.size.Size`
+            :keyword parents: a list of parent devices
+            :type parents: list of :class:`StorageDevice`
+            :keyword format: this device's formatting
+            :type format: :class:`~.formats.DeviceFormat` or a subclass of it
+            :keyword sysfsPath: sysfs device path
+            :type sysfsPath: str
+            :keyword uuid: the device UUID
+            :type uuid: str
+
+            For existing LVs only:
+
+            :keyword copies: number of copies in the vg (>1 for mirrored lvs)
+            :type copies: int
+            :keyword logSize: size of log volume (for mirrored lvs)
+            :type logSize: :class:`~.size.Size`
+            :keyword snapshotSpace: sum of sizes of snapshots of this lv
+            :type snapshotSpace: :class:`~.size.Size`
+            :keyword singlePV: if true, maps this lv to a single pv
+            :type singlePV: bool
+            :keyword segType: segment type (eg: "linear", "raid1")
+            :type segType: str
+
+            For non-existent LVs only:
+
+            :keyword grow: whether to grow this LV
+            :type grow: bool
+            :keyword maxsize: maximum size for growable LV
+            :type maxsize: :class:`~.size.Size`
+            :keyword percent -- percent of VG space to take
+            :type percent: int
 
         """
         if self.__class__.__name__ == "LVMLogicalVolumeDevice":
